//--------------------------------------------------------------------//
// ˊ֐

var viewModel;		// \f
var bounds;		// fE
var points=[];		// _Xg
var basePoints=[];	// _\IuWFNg
var curve=null;		// ԋȖ
var basisFunction;	// ֐
var w;			// d݌W

var NX=20,NY=20;		// ԋȖʂ̃bV
var MIN_DISTANCE_SQ=1.0e-6;	// _Ԃ̍ŏ
var POINT_SIZE=0.02;		// _Ԃ̕\TCYW
// _̕\}eA
var BASE_POINT_MAT=new THREE.MeshStandardMaterial
  ({color:0xffcc00,roughness:0.3,metalness:0.4});
// ԋȖʂ̕\}eA
var CURVE_MAT=new THREE.MeshStandardMaterial
  ({color:0x0033ff,roughness:0.3,metalness:0.4,side:THREE.DoubleSide,
    transparent:true,opacity:0.8});

// f[^
// fileName - f[^t@C
function initRbf(fileName){
  bounds=new Bounds();
  document.addEventListener('keydown',keyPressed,false);
  viewModel=new ViewModel('rbf-canvas');
  viewModel.setAxis();
  if((fileName!==null) && (fileName!==undefined)){
    readServerFile(fileName);
  }
  loop();
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 88:		// X
      viewModel.viewX();
      break;
    case 89:		// Y
      viewModel.viewY();
      break;
    case 45:		// Ins(Numpad0 Off)
    case 48:		// 0
    case 65:		// A
    case 90:		// Z
    case 96:		// Numpad0 On
      viewModel.viewZ();
      break;
  }
}

// WebT[o[̃t@Cǂݍ
// fileName - f[^t@C
function readServerFile(fileName){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      readData(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// ˊ֐ԃf[^ǂݍ
// s - f[^̃Xg
function readData(s){
  clearObject();
  points.length=0;
  for(var row=0;row<s.length;row++){
    var ss=s[row].trim().replace(/\t/g," ").split(/\s+/);
    if(ss.length>=3){
      addPoint(new DataPoint([Number(ss[0]),Number(ss[1])],
      	      	      	     Number(ss[2])));
    }
  }
  bounds.set();
  createBasePointObject();
  viewModel.updateLightAndCamera();
  viewModel.setAxis();
}

// f[^_ǉ
// p - f[^_
function addPoint(p){
  for(var i=0;i<points.length;i++){
    if(points[i].distanceSq(p)<=MIN_DISTANCE_SQ){
      return;
    }
  }
  points.push(p);
}

// ԋȖʂݒ肷
// f0 - a0ł̊֐̒l
// vars - ϐ̐
function createCurve(f0,vars){
  var len=points.length,size=len+vars+1,j;
  var matrix=numeric.rep([size,size],0);
  var vector=numeric.rep([size],0);
  for(var i=0;i<len;i++){
    matrix[i][i]=f0;
    for(j=i+1;j<len;j++){
      var d=basisFunction.getValue(j,points[i].x);
      matrix[i][j]=d;
      matrix[j][i]=d;
    }
    matrix[i][len]=1;
    matrix[len][i]=1;
    for(j=0;j<vars;j++){
      matrix[i][len+1+j]=points[i].x[j];
      matrix[len+1+j][i]=points[i].x[j];
    }
    vector[i]=points[i].f;
  }
  w=numeric.solve(matrix,vector);
  return new THREE.ParametricGeometry(interPoint,NX,NY);
}

// ԋȖʏ̓_Ԃ
// u,v - Ȗʏ̃p[^
function interPoint(u,v){
  var x=bounds.getXY(u,v),z=0,len=points.length;
  for(var i=0;i<len;i++){
    z+=w[i]*basisFunction.getValue(i,x);
  }
  z+=w[len];
  for(var j=0;j<2;j++){
    z+=w[len+1+j]*x[j];
  }
  return new THREE.Vector3(x[0],x[1],z);
}

// \IuWFNg
function clearObject(){
  for(var i=0;i<basePoints.length;i++){
    viewModel.removeObject(basePoints[i]);
  }
  basePoints.length=0;
  clearCurve();
}

// ԋȖʕ\IuWFNg
function clearCurve(){
  if(curve!==null){
    viewModel.removeObject(curve);
    curve=null;
  }
}

// _̕\IuWFNgݒ肷
function createBasePointObject(){
  basePoints.length=0;
  var baseGeom=new THREE.SphereGeometry(POINT_SIZE*bounds.size);
  for(var i=0;i<points.length;i++){
    basePoints[i]=new THREE.Mesh(baseGeom,BASE_POINT_MAT);
    basePoints[i].position.copy(points[i].p);
    viewModel.addObject(basePoints[i]);
  }
}

// [v֐
function loop(){
  viewModel.update();
  requestAnimationFrame(loop);
}

// Obh_쐬
function calc(){
  clearCurve();
  var type=document.getElementById('type').value;
  if(type=='gauss'){
    var radius=Number(document.getElementById('radius').value);
    basisFunction=new Gauss(radius);
    curve=new THREE.Mesh(createCurve(1,2),CURVE_MAT);
  }
  else{
    var order=Number(type.substring(5));
    basisFunction=new PolyharmonicSpline(order);
    curve=new THREE.Mesh(createCurve(0,2),CURVE_MAT);
  }
  viewModel.addObject(curve);
}

// [Jt@Cǂݍ
function readLocalFile() {
  var file=document.getElementById('localfile').files[0];
  var reader=new FileReader();
  reader.readAsText(file);
  reader.onload=function(e){
    readData(reader.result.split(/\r?\n/g));
  };
}

//--------------------------------------------------------------------//
// \f
// canvasId - \̈ID
var ViewModel=function(canvasId){
  this.canvasFrame=document.getElementById(canvasId);		// `t[
  this.renderer=new THREE.WebGLRenderer({antialias:true});	// _\
  if(!this.renderer){
    alert("three.js ̏Ɏs܂");
  }

  this.renderer.setSize(this.canvasFrame.clientWidth,
      	      	      	this.canvasFrame.clientHeight);
  this.canvasFrame.appendChild(this.renderer.domElement);

  this.renderer.setClearColor(0x000000,1.0);
  this.scene=new THREE.Scene();					// V[
  this.initLight();
  this.initCamera();
  this.axis=null;
};

// 
ViewModel.prototype.initLight=function(){
// s
  this.directionalLight=new THREE.DirectionalLight(0xffffff,1.0);
  bounds.setLightPosition(this.directionalLight.position);
  this.scene.add(this.directionalLight);
// 
  this.ambientLight=new THREE.AmbientLight(0xcccccc);
  this.scene.add(this.ambientLight);
};

// J
ViewModel.prototype.initCamera=function(){
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  var side=0.7*bounds.size,c=bounds.center;
// J
  this.camera=new THREE.OrthographicCamera
    (-side*aspect,side*aspect,side,-side,
     0.01*bounds.size,100*bounds.size);
  this.camera.position.set(c.x,c.y,c.z+bounds.viewPoint);
  this.camera.up.set(0,1,0);
//  this.camera.lookAt({x:0,y:0,z:0});	Controlsgp͖

// gbN{[Rg[
  this.trackball=new THREE.OrthographicTrackballControls
      	      	   (this.camera,this.canvasFrame);
  this.trackball.screen.width=this.canvasFrame.clientWidth;
  this.trackball.screen.height=this.canvasFrame.clientHeight;
  var bdc=this.canvasFrame.getBoundingClientRect();
  this.trackball.screen.offetLeft=bdc.left;
  this.trackball.screen.offetTop=bdc.top;

  this.trackball.noRotate=false;
  this.trackball.rotateSpeed=4.0;
  this.trackball.noZoom=false;
  this.trackball.zoomSpeed=4.0;
  this.trackball.noPan=false;
  this.trackball.panSpeed=1.0;
  this.trackball.target.copy(c);
  this.trackball.staticMoving=true;
  this.trackball.dynamicDampingFactor=0.3;
};

// \IuWFNgǉ
ViewModel.prototype.addObject=function(obj){
  this.scene.add(obj);
};

// \IuWFNg폜
ViewModel.prototype.removeObject=function(obj){
  this.scene.remove(obj);
  obj.geometry.dispose();
  obj.material.dispose();
};

// Wݒ肷
ViewModel.prototype.setAxis=function(){
  if(this.axis!==null){
    this.scene.remove(this.axis);
  }
  this.axis=new THREE.AxisHelper(0.2*bounds.size);
  this.axis.position.set(0,0,0);
  this.scene.add(this.axis);
};

// EJʒuXV
ViewModel.prototype.updateLightAndCamera=function(){
  bounds.setLightPosition(this.directionalLight.position);
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  var side=0.7*bounds.size;
  this.camera.left=-side*aspect;
  this.camera.right=side*aspect;
  this.camera.top=side;
  this.camera.bottom=-side;
  this.camera.near=0.01*bounds.size;
  this.camera.far=100*bounds.size;
  this.viewZ();
  this.trackball.update();
};

// \XV
ViewModel.prototype.update=function(){
  this.trackball.update();
  this.renderer.render(this.scene,this.camera);
};

// _Xɂ
ViewModel.prototype.viewX=function(){
  var c=bounds.center;
  this.camera.position.set(c.x+bounds.viewPoint,c.y,c.z);
  this.camera.up.set(0,0,1);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

// _Yɂ
ViewModel.prototype.viewY=function(){
  var c=bounds.center;
  this.camera.position.set(c.x,c.y-bounds.viewPoint,c.z);
  this.camera.up.set(0,0,1);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

// _Zɂ
ViewModel.prototype.viewZ=function(){
  var c=bounds.center;
  this.camera.position.set(c.x,c.y,c.z+bounds.viewPoint);
  this.camera.up.set(0,1,0);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

//--------------------------------------------------------------------//
// fE
var Bounds=function(){
  this.box=new THREE.Box3();
  this.center=new THREE.Vector3();
  this.size=1;
  this.viewPoint=1;
};

// fEݒ肷
Bounds.prototype.set=function(){
  var vecs=[];
  for(var i=0;i<points.length;i++){
    vecs[i]=points[i].p;
  }
  this.box.setFromPoints(vecs);
  this.center.copy(this.box.getCenter());
  this.size=Math.max(this.box.max.x-this.box.min.x,
      	      	     this.box.max.y-this.box.min.y,
      	      	     this.box.max.z-this.box.min.z);
  this.viewPoint=2*this.size;
};

// X,YWԂ
// u,v - XYʏ̃p[^
Bounds.prototype.getXY=function(u,v){
  return [this.box.min.x+(this.box.max.x-this.box.min.x)*u,
      	  this.box.min.y+(this.box.max.y-this.box.min.y)*v];
};

// ʒuݒ肷
// p - ʒu
Bounds.prototype.setLightPosition=function(p){
  p.set(this.size,-this.size,this.size);
};

//--------------------------------------------------------------------//
// f[^_
// x - f[^ϐz
// f - ֐l
var DataPoint=function(x,f){
  this.x=x;
  this.f=f;
// 3W
  if(x.length>=2){
    this.p=new THREE.Vector3(x[0],x[1],f);
  }
  else if(x.length==1){
    this.p=new THREE.Vector3(x[0],0.0,f);
  }
  else{
    this.p=new THREE.Vector3(0.0,0.0,f);
  }
};

// _Ƃ̋2Ԃ
// p - 𑪂Ώۂ̃f[^_
DataPoint.prototype.distanceSq=function(p){
  return this.distanceSqX(p.x);
};

// _Ƃ̋2Ԃ
// x - 𑪂Ώۂ̃f[^_W
DataPoint.prototype.distanceSqX=function(x){
  var s=0,len=this.x.length;
  for(var i=0;i<len;i++){
    var dx=this.x[i]-x[i];
    s+=dx*dx;
  }
  return s;
};

//--------------------------------------------------------------------//
// KEX֐
// r - a
var Gauss=function(r){
  this.ri=1.0/(r*r);
};

// ֐̒lvZ
// i - _̃CfbNX
// x - _̍Wi[z
Gauss.prototype.getValue=function(i,x){
  return Math.exp(-this.ri*points[i].distanceSqX(x));
};

//--------------------------------------------------------------------//
// daXvC֐
// order - 
var PolyharmonicSpline=function(order){
  this.order=order;
};

// ֐̒lvZ
// i - _̃CfbNX
// x - _̍Wi[z
PolyharmonicSpline.prototype.getValue=function(i,x){
  var r=points[i].distanceSqX(x);
  if(r===0){
    return 0;
  }
  else if(this.order%2===0){
    r=Math.sqrt(r);
    return Math.pow(r,this.order)*Math.log(r);
  }
  else{
    return Math.pow(Math.sqrt(r),this.order);
  }
};
